'use strict';

var _join2 = require('ramda/src/join');

var _join3 = _interopRequireDefault(_join2);

var _fs = require('fs');

var _fs2 = _interopRequireDefault(_fs);

var _glob = require('glob');

var _glob2 = _interopRequireDefault(_glob);

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _Rx = require('rxjs/Rx');

var _Rx2 = _interopRequireDefault(_Rx);

var _utils = require('./utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var srcPattern = process.argv[2]; /* eslint no-console:0 */

var desPath = process.argv[3];

process.env.NODE_ENV = 'production'; // for babel

// --- /src/a.js --- /src/b.js --- ...
var srcPath$ = _Rx2.default.Observable.of(srcPattern).switchMap(function (pattern) {
  return _Rx2.default.Observable.from(_glob2.default.sync(pattern));
});

// --- a --- b --- ...
var basename$ = srcPath$.map(function (srcPath) {
  return _path2.default.basename(srcPath, _path2.default.extname(srcPath));
});

// --- 'export a' --- 'export b' --- ...
var strings$ = basename$.map(function (basename) {
  return 'export { default as ' + basename + ' } from \'./' + basename + '\';';
});

// --- 'export a \n export b' |
var resultsES6$ = strings$.toArray().map((0, _join3.default)('\n'));

var resultsES5$ = resultsES6$.map(_utils.compile);

// Output
resultsES5$.subscribe(function (results) {
  _fs2.default.writeFileSync(desPath, results);
  console.log(_path2.default.relative(process.cwd(), srcPattern) + ' -> ' + _path2.default.relative(process.cwd(), desPath));
}, function (error) {
  return console.error(error);
});