'use strict';

var _assoc2 = require('ramda/src/assoc');

var _assoc3 = _interopRequireDefault(_assoc2);

var _path2 = require('ramda/src/path');

var _path3 = _interopRequireDefault(_path2);

var _fs = require('fs');

var _fs2 = _interopRequireDefault(_fs);

var _glob = require('glob');

var _glob2 = _interopRequireDefault(_glob);

var _path4 = require('path');

var _path5 = _interopRequireDefault(_path4);

var _Rx = require('rxjs/Rx');

var _Rx2 = _interopRequireDefault(_Rx);

var _child_process = require('child_process');

var _babelCore = require('babel-core');

var babel = _interopRequireWildcard(_babelCore);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/* eslint no-console:0 */

var srcPattern = process.argv[2];
var desPath = process.argv[3];

process.env.NODE_ENV = 'production'; // for babel

// -- ./src/**/*.js |
var srcPattern$ = _Rx2.default.Observable.of(srcPattern);

// --- /Users/project/src/a.js --- /Users/project/src/b.js --- ...
var srcPath$ = srcPattern$.switchMap(function (pattern) {
  return _Rx2.default.Observable.from(_glob2.default.sync(pattern, { absolute: true }));
});

// --- ./src/a.js --- ./src/b.js --- ...
var relativeSrcPath$ = srcPattern$.switchMap(function (pattern) {
  return _Rx2.default.Observable.from(_glob2.default.sync(pattern));
});

// --- contentA --- contentB --- ...
var content$ = srcPath$.map(function (filepath) {
  return _fs2.default.readFileSync(filepath, 'utf-8');
});

// --- [] --- [] --- [{}, {}] --- ...
var messages$ = content$.map(function (content) {
  return babel.transform(content, {
    presets: [require.resolve('babel-preset-react-app')],
    plugins: [require.resolve('babel-plugin-react-intl')],
    babelrc: false
  });
}).map((0, _path3.default)(['metadata', 'react-intl', 'messages']));

// ---------- JSON:[{}, {}] |

var results$ = messages$.zip(relativeSrcPath$, function (messages, relativeSrcPath) {
  return messages.map((0, _assoc3.default)('filepath', relativeSrcPath));
}).filter(function (messages) {
  return messages.length !== 0;
}).reduce(function (acc, messages) {
  return acc.concat(messages);
}, []).map(function (concated) {
  return JSON.stringify(concated, null, 2);
});

// Output
results$.subscribe(function (results) {
  (0, _child_process.spawnSync)('mkdir', ['-p', _path5.default.dirname(desPath)]);
  _fs2.default.writeFileSync(desPath, results);
  console.log(_path5.default.relative(process.cwd(), srcPattern) + ' -> ' + _path5.default.relative(process.cwd(), desPath));
}, function (error) {
  return console.error(error);
});