'use strict';

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }(); /* eslint no-console:0 */

var _fs = require('fs');

var _fs2 = _interopRequireDefault(_fs);

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _Rx = require('rxjs/Rx');

var _Rx2 = _interopRequireDefault(_Rx);

var _lodash = require('lodash.camelcase');

var _lodash2 = _interopRequireDefault(_lodash);

var _lodash3 = require('lodash.upperfirst');

var _lodash4 = _interopRequireDefault(_lodash3);

var _child_process = require('child_process');

var _utils = require('./utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var srcDir = process.argv[2];
var desDir = process.argv[3];

process.env.NODE_ENV = 'production'; // for babel

// --- /lib/a.svg --- /lib/b.svg --- ...
var srcPath$ = _Rx2.default.Observable.of(srcDir).switchMap(function (dirPath) {
  return _Rx2.default.Observable.from(_fs2.default.readdirSync(dirPath));
}).map(function (basename) {
  return _path2.default.resolve(srcDir, basename);
});

// --- IconA --- IconB --- ...
var componentName$ = srcPath$.map(function (filepath) {
  return _path2.default.basename(filepath, _path2.default.extname(filepath));
}).map(_lodash2.default).map(_lodash4.default);

// --- xmlA --- xmlB --- ...
var xml$ = srcPath$.map(function (filepath) {
  return _fs2.default.readFileSync(filepath, 'utf-8');
});

// --- codeA --- codeB --- ...
var code$ = _Rx2.default.Observable.zip(componentName$, xml$).map(function (_ref) {
  var _ref2 = _slicedToArray(_ref, 2),
      componentName = _ref2[0],
      xml = _ref2[1];

  return (0, _utils.compile)((0, _utils.template)(componentName, (0, _utils.parseSVG)(xml)));
});

// --- ./lib/IconA.js --- ./lib/IconB.js --- ...
var destPath$ = componentName$.map(function (componentName) {
  return _path2.default.resolve(desDir, componentName + '.js');
}).do(function (destPath) {
  return (0, _child_process.spawnSync)('mkdir', ['-p', _path2.default.dirname(destPath)]);
});

// Output
_Rx2.default.Observable.zip(srcPath$, code$, destPath$).subscribe(function (_ref3) {
  var _ref4 = _slicedToArray(_ref3, 3),
      srcPath = _ref4[0],
      code = _ref4[1],
      destPath = _ref4[2];

  _fs2.default.writeFileSync(destPath, code);
  console.log(_path2.default.relative(process.cwd(), srcPath) + ' -> ' + _path2.default.relative(process.cwd(), destPath));
}, function (error) {
  return console.error(error);
});